QuakeScheme - Scheme to accomodate Q3VM's idiosyncrasies
$Id: README.QS,v 1.1 2002/01/25 06:06:41 phaethon Exp $
http://www.icculus.org/fi/

   PhaethonH <phaethon@linux.ucla.edu>


.......................................

Table of Contents
 1. Background
 2. R5RS compliance
 3. SRFI extensions
 4. SLIB compatibility
 5. Local extensions
 6. Q3A-specific extensions
 7. Portability
.......................................




=============
1. BACKGROUND
=============

QuakeScheme was created from scratch instead of borrowing/hacking other free Schemes for the following reasons:
 * QVM bytecode form lacks a malloc().
 * QVM bytecode does not lend itself to setjump()/longjmp() working.
 * QVM has a very limited stack space (1MB but expandable at compile-time).
 * The author felt like learning the internals of Scheme/Lisp the hard way.

Current garbage collection technique is mark-and-sweep.

Memory model is based on array-of-pairs, with an external array for data type and flagging information.

This is a rather lousy implementation of Scheme.  If you're looking to
integrate Scheme into your (non-Quake3) project, you may be better off looking
at the more-complete and better-tested free Scheme implementations, like
MIT Scheme, Scheme48, SIOD, or SCM.  Or even GNU Guile.




==================
2. R5RS Compliance
==================
(http://www.swiss.ai.mit.edu/~jaffer/r5rs_toc.html)

QuakeScheme is properly tail-recursive (not extensively proven).

Most of the R5RS required primitives are implemented.

Non-working required primitives:
 * values
 * call-with-values
 * dynamic-wind
 * syntax-rules
 * char-ready?
 * syntax-rules

R5RS macros are NOT implemented.

R5RS primitives that are faked or otherwise pretends to succeed:
 * call-with-current-continuation (using catch/throw)
 * equal? (just calls eqv?)

R5RS numeric tower implemented:
 * 32-bit fixnum (integers)
 * 32-bit flonum (floats)
 * exact numbers and fixnums are equivalent.
 * inexact numbers and flonums are equivalent.

Complex and Rational numbers are not implemented, and their associated procedures remain unimplemented.

R5RS data types implemented:
 * Numbers (fixnum, flonum)
 * Boolean
 * Pair
 * Symbol
 * Character
 * String
 * Vector
 * Port




==================
3. SRFI Compliance
==================
(http://srfi.schemers.org/)

None, not even SRFI-0.





=====================
4. SLIB Compatibility
=====================
(url???)

Not implemented




===================
5. Local Extensions
===================

Many extensions were inspired by GNU Guile, the GNU extensible language based on Scheme.

Additional data types:
 * Structure Layout
 * Structure




================================
6. Extensions for Quake 3: Arena
================================

Most of the system traps on the server-side ("game" modules) are wrapped.
Since the source should be available, I won't go into specific details on
which are wrapped and which aren't.

Dedicated servers are patched to recognize any lines that start with an opening
parenthesis ((), and will attempt to execute such lines as Scheme code.




==============
7. Portability
==============

QuakeScheme is intended to remain portable.
Particular attention has been paid to stand-alone and the Quake series.
